#include<bits/stdc++.h>
using namespace std;
#define MAXN 500007
#define ll long long
int a[MAXN];
string s;
bool checkright(int k)
{
    int n=s.length();
    if(k>n/2)
    {
        map<char,int>m;
        for(int i=n-1;i>=n-k;i--)
        {
            m[s[i]]++;
        }
        for(int i=0;i<n-k;i++)
        {
            m[s[i]]--;
            if(m[s[i]]<0)
            {
                return false;
            }
        }
        return true;
    }
    else
    {
        vector<int>v(26);
        for(int i=0;i<k;i++)
        {
            v[s[i]-'a']++;
        }
        for(int i=n-k;i<n;i++)
        {
            v[s[i]-'a']++;
        }
        for(int i=0;i<26;i++)
        {
            if(v[i]!=0)
            {
                return 0;
            }
        }
        for(int i=k;i<n-k;i++)
        {
            if(s[i]!=s[n-1-i])
            {
                return false;
            }
        }
        return true;
    }
}
bool checkleft(int k)
{
    int n=s.length();
    if(k>n/2)
    {
        map<char,int>m;
        for(int i=0;i<k;i++)
        {
            m[s[i]]++;
        }
        for(int i=n-1;i>=k;i--)
        {
            m[s[i]]--;
            if(m[s[i]]<0)
            {
                return false;
            }
        }
        return true;
    }
    else
    {
        vector<int>v(26);
        for(int i=0;i<k;i++)
        {
            v[s[i]-'a']++;
        }
        for(int i=n-k;i<n;i++)
        {
            v[s[i]-'a']++;
        }
        for(int i=0;i<26;i++)
        {
            if(v[i]!=0)
            {
                return 0;
            }
        }
        for(int i=k;i<n-k;i++)
        {
            if(s[i]!=s[n-1-i])
            {
                return false;
            }
        }
        return true;
    }
}
int minshuffle(int n)
{
    int l=1,r=n,mid;
    int res=n;
    while(l<=r)
    {
        mid=(l+r)/2;
        if(checkleft(mid) || checkright(mid))
        {
            r=mid-1;
            res=mid;
        }
        else
        {
            l=mid+1;
        }
    }
    return res;
}
int solve(string s1)
{
    int cnt=0;
    int n=s1.length();
    while(s1[cnt]==s1[n-1-cnt])
    {
        cnt++;
    }
    for(int i=cnt;i<n-cnt;i++)
    {
        s+=s1[i];
    }
    if(s=="")
    {
        cout<<1<<endl;
        return 0;
    }
    else
    {
        cout<<minshuffle(s.length())<<endl;
        return 0;
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);
    int t=1;
    int n;
    string s1;
    //cin>>t;
    for(int i=0;i<t;i++)
    {
        cin>>s1;
        solve(s1);
    }
}